Index: squid/src/HintCacheHier.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/HintCacheHier.c,v
retrieving revision 1.1.2.1
retrieving revision 1.1.2.2
diff -u -r1.1.2.1 -r1.1.2.2
--- squid/src/HintCacheHier.c	20 Nov 2001 06:50:12 -0000	1.1.2.1
+++ squid/src/HintCacheHier.c	21 May 2002 02:46:41 -0000	1.1.2.2
@@ -1,8 +1,8 @@
 /*
- * $Date: 2001/11/20 06:50:12 $ $Id: HintCacheHier.c,v 1.1.2.1 2001/11/20 06:50:12 jkay Exp $
+ * $Date: 2002/05/21 02:46:41 $ $Id: HintCacheHier.c,v 1.1.2.2 2002/05/21 02:46:41 jkay Exp $
  *
  * AUTHOR: Mike Dahlin, UT Austin, 1998
- * DEBUG:  section 61,  Hint cache hierarchy.
+ * DEBUG:  section 86,  Hint cache hierarchy.
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
  * --------------------------------------------------------
@@ -76,20 +76,20 @@
  *	recv "I am not child" from child: remove child
  */
 
-#define HCHIER_DEBUG 61
+#define HCHIER_DEBUG 86
 
 #ifdef DOTEST
 static int doTestBarrier(int barrier);
 static void writeTestBarrier(int barrier);
 static int readTestBarrier(int barrier);
 static void clearTestBarrier();
-static void testFindPeer(peer *p);
+static void testFindPeer(peer * p);
 static void testPlax(void);
 static void testCreateStuff(char *tag);
 static void testFind(void);
 static void testFindStuff(char *tag, const struct sockaddr_in *expect);
 #endif /* DOTEST */
-  
+
 /*
  * These must be an set of values each one greater than the
  * last to define the series of states for the network test.
@@ -106,43 +106,42 @@
 #define BARRIER_FIND 1009
 #define BARRIER_LAST 1010
 #define BARRIER_DONE 9999
- 
-int HCHier_selfTestDone = 0;
+
+int HintCacheHier_selfTestDone = 0;
 
 
-List_Links HCHier_Nodes;
+dlink_list HintCacheHier_Nodes;
 
-int scanIDs _PARAMS((List_Links *l, char *b, int *count));
-int scanIDDistances _PARAMS((List_Links *l, char *b, int *count));
+int scanIDs (dlink_list * l, char *b, int *count);
+int scanIDDistances (dlink_list * l, char *b, int *count);
 
 void
-HCHier_Init(void)
+hintCacheHier_Init(void)
 {
-  HCNLIter iter;
-  struct sockaddr_in saddr;
-  /*
-   * This should be set in config file
-   */
-  static int bitsPerLevelXXX = 8;
-
-  HCNodelist_Init();
-  HCPlax_Init(bitsPerLevelXXX);
-  HCNodelist_LocalJoin();
-  for(HCNodeList_IterStart(&iter);
-      HCNodeList_IterCheck(iter);
-      HCNodeList_IterNext(&iter)){
-    if(HCNodeList_IterGetAddr(iter, &saddr)){
-      HCPlax_addNode(&saddr);
+    HintCacheNodeListIter iter;
+    struct sockaddr_in saddr;
+    /*
+     * This should be set in config file
+     */
+    static int bitsPerLevelXXX = 8;
+
+    HintCacheNodelist_Init();
+    HintCachePlax_Init(bitsPerLevelXXX);
+    HintCacheNodelist_LocalJoin();
+    for (HintCacheNodeList_IterStart(&iter);
+	hintCacheNodeList_IterCheck(iter); hintCacheNodeList_IterNext(&iter)) {
+	if (hintCacheNodeList_IterGetAddr(iter, &saddr)) {
+	    hintCachePlax_addNode(&saddr);
+	}
     }
-  }
 }
 
 void
-HCHier_Destroy(void)
+hintCacheHier_Destroy(void)
 {
-  HCNodelist_LocalLeave();
-  HCNodelist_Destroy();
-  HCPlax_Destroy();
+    hintCacheNodelist_LocalLeave();
+    hintCacheNodelist_Destroy();
+    hintCachePlax_Destroy();
 }
 
 /*
@@ -166,22 +165,17 @@
  *----------------------------------------------------7.18.1998---------
  */
 void
-HCHier_updateMembershipNeighbor(struct sockaddr_in *neighbor, 
-                                     NeighborAction action)
+hintCacheHierUpdateMembershipNeighbor(struct sockaddr_in *neighbor,
+    NeighborAction action)
 {
-  if(action == NEIGHBOR_ADD){
-    HCNodelist_addMembershipNeighbor(neighbor);
-  }
-  else{
-    HCNodelist_rmMembershipNeighbor(neighbor);
-  }    
+    /* Currently nothing */
 }
 
 
 /*
  *------------------------------------------------------------------
  *
- * HCHier_compareDistanceFromMe --
+ * hintCacheHierCompareDistanceFromMe --
  *
  *          Return <0 if new node is closer than old node, 0 if same
  *          distance, >0 if new node is closer than old  node.
@@ -201,7 +195,7 @@
  *------------------------------------------------------------------
  */
 int
-HCHier_compareDistanceFromMe(struct in_addr new, struct in_addr old)
+hintCacheHierCompareDistanceFromMe(struct in_addr new, struct in_addr old)
 {
     int nrtt, ortt;
     int nhops, ohops;
@@ -215,7 +209,7 @@
     strcpy(name, inet_ntoa(old));
     ortt = netdbHostRtt(name);
     if (nrtt && ortt)
-	return(nrtt - ortt);
+	return (nrtt - ortt);
 
     /* Otherwise compare hopcount */
     nhops = netdbHintHops(new);
@@ -223,15 +217,15 @@
 
     /* If either host is unknown, say new one is nearer */
     if (nhops == 0 || ohops == 0)
-	return(-1);
-    
-    return(nhops - ohops);
+	return (-1);
+
+    return (nhops - ohops);
 }
 
 /*
  *------------------------------------------------------------------
  *
- * HCHier_newNode --
+ * hintCacheHierNewNode --
  *
  *          This gets called when we hear about a new node in the system.
  *
@@ -247,16 +241,15 @@
  *-------------------------------------------------4.1.1998-----------
  */
 void
-HCHier_newNode(struct sockaddr_in *sin, int hops, 
-	       long long joinTimeNS)
+hintCacheHierNewNode(struct sockaddr_in *sin, int hops, long long joinTimeNS)
 {
-  HCNodelist_NetJoin(sin, hops, joinTimeNS);
+    hintCacheNodelist_NetJoin(sin, hops, joinTimeNS);
 }
 
 /*
  *------------------------------------------------------------------
  *
- * HCHier_delNode --
+ * hintCacheHierDelNode --
  *
  *          This gets called when we hear about a node leaving the system
  *
@@ -272,16 +265,15 @@
  *-------------------------------------------------4.1.1998-----------
  */
 void
-HCHier_delNode(struct sockaddr_in *sin, int hops, 
-	       long long joinTimeNS)
+hintCacheHierDelNode(struct sockaddr_in *sin, int hops, long long joinTimeNS)
 {
-    HCNodelist_NetLeave(sin, hops, joinTimeNS);
+    hintCacheNodelist_NetLeave(sin, hops, joinTimeNS);
 }
 
 /*
  *------------------------------------------------------------------
  *
- * HCHier_CheckIfParent --
+ * hintCacheHierCheckIfParent --
  *
  *          See if the specified node is really my parent.
  *
@@ -296,11 +288,11 @@
  *
  *---------------------------------------------------4.10.1998---------
  */
-int 
-HCHier_CheckIfParent (URLKey key, struct sockaddr_in *candidate)
+int
+hintCacheHierCheckIfParent(URLKey key, struct sockaddr_in *candidate)
 {
-#ifdef USE_DYNAMIC_HIERARCHY
-    return HCPlax_CheckIfParent(key, candidate);
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlax_CheckIfParent(key, candidate);
 #else
     /* 
      * For static algorithm, anyone that wants to be my parent can 
@@ -313,7 +305,7 @@
 /*
  *------------------------------------------------------------------
  *
- * HCHier_CheckIfChild --
+ * hintCacheHier_CheckIfChild --
  *
  *          See if the specified node is really my child.
  *
@@ -328,11 +320,11 @@
  *
  *---------------------------------------------------4.10.1998---------
  */
-int 
-HCHier_CheckIfChild (struct sockaddr_in *candidate)
+int
+hintCacheHierCheckIfChild(struct sockaddr_in *candidate)
 {
-#ifdef USE_DYNAMIC_HIERARCHY
-    return HCPlax_CheckIfChild(candidate);
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlax_CheckIfChild(candidate);
 #else
     /* 
      * For static algorithm, anyone that wants to be my child can 
@@ -345,7 +337,7 @@
 /*
  *------------------------------------------------------------------
  *
- * HCHier_AddChild --
+ * hintCacheHierAddChild --
  *
  *          This node has claimed to by my child, so add it
  *          to the dynamic hierarchy.
@@ -361,11 +353,11 @@
  *
  *-----------------------------------------------------4.10.1998--------
  */
-void 
-HCHier_AddChild (struct sockaddr_in *child)
+void
+hintCacheHierAddChild(struct sockaddr_in *child)
 {
-#ifdef USE_DYNAMIC_HIERARCHY
-    HCPlax_AddChild(child);
+#if USE_DYNAMIC_HIERARCHY
+    hintCachePlax_AddChild(child);
 #else
     /*
      * For static algorithm, I don't track children.
@@ -378,7 +370,7 @@
 /*
  *------------------------------------------------------------------
  *
- * HCHier_RemoveChild --
+ * hintCacheHierRemoveChild --
  *
  *          This node denies paternity. Disinherit it.
  *
@@ -393,10 +385,11 @@
  *
  *---------------------------------------------------4.10.1998----------
  */
-void HCHier_RemoveChild (struct sockaddr_in *child)
+void
+hintCacheHierRemoveChild(struct sockaddr_in *child)
 {
-#ifdef USE_DYNAMIC_HIERARCHY
-    HCPlax_RemoveChild(child);
+#if USE_DYNAMIC_HIERARCHY
+    hintCachePlax_RemoveChild(child);
 #else
     /*
      * For static algorithm, I don't track children.
@@ -412,25 +405,25 @@
 
 /*  Each children queue holds messages that should go to a set of
  * "equivalent" children  (eg. the children at some level of the
- * hierarchy.)  There are HCHier_NChildrenQs() such queues;
- * Child queue q contains c = HCHier_ChildrenPerQ(q) children.
+ * hierarchy.)  There are hintCacheHier_NChildrenQs() such queues;
+ * Child queue q contains c = hintCacheHier_ChildrenPerQ(q) children.
  * The addresses of the children can be found with the function
- * HCHier_GetChildAddr(q, c);
+ * hintCacheHier_GetChildAddr(q, c);
  *
  * Each parent queue holds messages that should go to one parent.
  * In general, we may have different parents for different objects.
  * So, enqueue messages for an object in the queue
- * HCHier_ParentQIndex(URLKey).
+ * hintCacheHier_ParentQIndex(URLKey).
  */
 
 /*
  *------------------------------------------------------------------
  *
- * HCHier_ChildQIndex --
+ * hintCacheHierChildQIndex --
  *
  *          Return the index into the array of queues of 
  *          children for children that are my children 
- *          for this object. (See HCPlax for how
+ *          for this object. (See hintCachePlax for how
  *          children are grouped into levels.)
  *
  *          Also, if I have no children for this object,
@@ -447,12 +440,12 @@
  *
  *-----------------------------------------------4.10.1998-------------
  */
-int 
-HCHier_ChildQIndex(URLKey *key, int iAmRoot, int *amILeaf)
+int
+hintCacheHierChildQIndex(URLKey * key, int iAmRoot, int *amILeaf)
 {
-  assert(amILeaf != NULL); 
-#ifdef USE_DYNAMIC_HIERARCHY
-    return HCPlax_ChildQIndex(key, iAmRoot, amILeaf);
+    assert(amILeaf != NULL);
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlax_ChildQIndex(key, iAmRoot, amILeaf);
 #else
     /*
      * For static algorithm, we have one set of children and
@@ -466,12 +459,12 @@
 /*
  *------------------------------------------------------------------
  *
- * HCHier_NChildrenQs --
+ * hintCacheHierNChildrenQs --
  *
  *          Return the number of outgoing message queues
  *          to different classes of children. Each
  *          "class" corresponds to children for which 
- *          I am a parent. (See HCPlax for how
+ *          I am a parent. (See hintCachePlax for how
  *          children are grouped into levels.)
  *
  * Arguments:
@@ -485,10 +478,11 @@
  *
  *------------------------------------------------4.10.1998------------
  */
-int HCHier_NChildrenQs(void)
+int
+hintCacheHierNChildrenQs(void)
 {
-#ifdef USE_DYNAMIC_HIERARCHY
-    return HCPlax_NChildrenQs();
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlax_NChildrenQs();
 #else
     /*
      * For static algorithm, we have one set of children and
@@ -503,7 +497,7 @@
 /*
  *------------------------------------------------------------------
  *
- * HCHier_GetChildAddrs --
+ * hintCacheHierGetChildAddrs --
  *
  *        Return the number of children for the specified message
  *        queue, allocate a buffer for that many addresses,
@@ -527,29 +521,29 @@
  *
  *------------------------------------------------4.16.1998------------
  */
-int 
-HCHier_GetChildAddrs(int qIndex, struct sockaddr_in **retAddrAP)
+int
+hintCacheHierGetChildAddrs(int qIndex, struct sockaddr_in **retAddrAP)
 {
 #ifndef USE_DYNAMIC_HIERARCHY
-  peer *p;
-  int count = 0, nchildren = 0;
+    peer *p;
+    int count = 0, nchildren = 0;
 #endif
 
-  assert(retAddrAP);
-  assert(qIndex < HCHier_NChildrenQs());
+    assert(retAddrAP);
+    assert(qIndex < hintCacheHierNChildrenQs());
 
-#ifdef USE_DYNAMIC_HIERARCHY
-    return HCPlax_GetChildAddrs(qIndex, retAddrAP);
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlaxGetChildAddrs(qIndex, retAddrAP);
 #else
     assert(qIndex == 0);
     for (p = getFirstPeer(); p; p = getNextPeer(p)) {
-      nchildren++;
+	nchildren++;
     }
-    *retAddrAP = (struct sockaddr_in *)xmalloc(nchildren
-					     * sizeof(struct sockaddr_in));
+    *retAddrAP = (struct sockaddr_in *) xmalloc(nchildren
+	* sizeof(struct sockaddr_in));
     for (p = getFirstPeer(); p; p = getNextPeer(p)) {
-      (*retAddrAP)[count] = p->in_addr;
-      count++;
+	(*retAddrAP)[count] = p->in_addr;
+	count++;
     }
     /*
      * Squid promises that we run atomically
@@ -562,7 +556,7 @@
 /*
  *------------------------------------------------------------------
  *
- * HCHier_NParentQs --
+ * hintCacheHierNParentQs --
  *
  *          How many different message queues are they for different
  *          parents?
@@ -578,10 +572,11 @@
  *
  *--------------------------------------------------4.10.1998---------
  */
-int HCHier_NParentQs(void)
+int
+hintCacheHierNParentQs(void)
 {
-#ifdef USE_DYNAMIC_HIERARCHY
-    return HCPlax_NParentQs();
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlaxNParentQs();
 #else
     /*
      * For static algorithm, we have one parent
@@ -595,7 +590,7 @@
 /*
  *------------------------------------------------------------------
  *
- * HCHier_ParentQIndex --
+ * hintCacheHierParentQIndex --
  *
  *          Return the index of the queue I should use to talk
  *          to the parent for the specified object (set amIRoot
@@ -612,11 +607,12 @@
  *
  *---------------------------------------------------4.10.1998---------
  */
-int HCHier_ParentQIndex(URLKey *key, int *amIRoot)
+int
+hintCacheHierParentQIndex(URLKey * key, int *amIRoot)
 {
-  assert(amIRoot != NULL);
-#ifdef USE_DYNAMIC_HIERARCHY
-    return HCPlax_ParentQIndex(key, amIRoot);
+    assert(amIRoot != NULL);
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlaxParentQIndex(key, amIRoot);
 #else
     /*
      * For static algorithm, we have one parent
@@ -630,7 +626,7 @@
 /*
  *------------------------------------------------------------------
  *
- * HCHier_GetParentAddr --
+ * hintCacheHierGetParentAddr --
  *
  *          Return the address of the node that is curerntly
  *          the parent for the specified message queue.
@@ -646,23 +642,24 @@
  *
  *-----------------------------------------------------4.10.1998-------
  */
-int HCHier_GetParentAddr(int index, struct sockaddr_in *retAddr)
+int
+hintCacheHierGetParentAddr(int index, struct sockaddr_in *retAddr)
 {
-#ifdef USE_DYNAMIC_HIERARCHY
-    return HCPlax_GetParentAddr(index, retAddr);
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlaxGetParentAddr(index, retAddr);
 #else
     peer *p;
-    
+
     for (p = getFirstPeer(); p; p = getNextPeer(p)) {
-      if(p->type == PEER_PARENT){
-	*retAddr = p->in_addr;
-	return 0;
-      }
+	if (p->type == PEER_PARENT) {
+	    *retAddr = p->in_addr;
+	    return 0;
+	}
     }
     p = getFirstPeer();
-    if(p){
-      *retAddr = p->in_addr;
-      return 0;
+    if (p) {
+	*retAddr = p->in_addr;
+	return 0;
     }
     return -1;
 #endif
@@ -670,9 +667,9 @@
 
 
 int
-HCHier_SendToParent(struct sockaddr_in *src, HCUpdate *update, int msgtype)
+hintCacheHierSendToParent(struct sockaddr_in *src, HintCacheUpdate * update, int msgtype)
 {
-#ifdef USE_DYNAMIC_HIERARCHY
+#if USE_DYNAMIC_HIERARCHY
     int stillHave;
     int pIndex, cIndex;
     int iAmRoot, iAmLeaf;
@@ -680,52 +677,53 @@
     peer *e;
 #endif
 
-#ifdef USE_DYNAMIC_HIERARCHY
-    pIndex = HCHier_ParentQIndex(&update->entry.key, &iAmRoot);
+#if USE_DYNAMIC_HIERARCHY
+    pIndex = hintCacheHierParentQIndex(&update->entry.key, &iAmRoot);
 #else
     for (e = getFirstPeer(); e; e = getNextPeer(e)) {
 	if (e->type != PEER_PARENT)
 	    continue;
 	if (e->in_addr.sin_addr.s_addr == src->sin_addr.s_addr
 	    && e->http_port == src->sin_port) {
-	    if (e->type != PEER_PARENT)  {
+	    if (e->type != PEER_PARENT) {
 		debug(HCHIER_DEBUG, 0,
-		      "warning: got parental msg from non-parent <%s,%d>.\n",
-		      inet_ntoa(src->sin_addr), src->sin_port);
+		    "warning: got parental msg from non-parent <%s,%d>.\n",
+		    inet_ntoa(src->sin_addr), src->sin_port);
 		debug(HCHIER_DEBUG, 0,
-		      "    Not propagating it.  Configuration mismatch?\n");
-		return(-1);
+		    "    Not propagating it.  Configuration mismatch?\n");
+		return (-1);
 	    }
 	    continue;
 	}
-	HCNet_Enqueue(&e->hcoutq, msgtype, &update->entry, update->hopcount + 1);
+	hintCacheNetEnqueue(&e->hcoutq, msgtype, &update->entry,
+	    update->hopcount + 1);
     }
     if (e == 0) {
 	/* Not found. */
-	return(-1);
+	return (-1);
 	/* Don't propagate */
     }
 #endif
-    
-#ifdef USE_DYNAMIC_HIERARCHY
+
+#if USE_DYNAMIC_HIERARCHY
     /* Send message */
-    if(!iAmRoot) {
-	assert(pIndex < HCHier_NParentQs());
-	HCNet_Enqueue(&parentOutgoingA[pIndex], msgtype, &update->entry,
-		      update->hopcount+1);
+    if (!iAmRoot) {
+	assert(pIndex < hintCacheHier_NParentQs());
+	hintCacheNetEnqueue(&parentOutgoingA[pIndex], msgtype, &update->entry,
+	    update->hopcount + 1);
     }
 #endif
-    
-    return(0);
+
+    return (0);
 }
 
 
 
 int
-HCHier_SendToSiblings(struct sockaddr_in *src, HCUpdate *update,
-		      int msgtype, int siblingtype)
+hintCacheHierSendToSiblings(struct sockaddr_in *src, HintCacheUpdate * update,
+    int msgtype, int siblingtype)
 {
-#ifdef USE_DYNAMIC_HIERARCHY
+#if USE_DYNAMIC_HIERARCHY
     int stillHave;
     int pIndex, cIndex;
     int iAmRoot, iAmLeaf;
